
Foreman - Bug #20720

'hammer host update' fails on VMware provisionned hosts 

08/23/2017 05:12 PM - Anthony Chevalet

Status: Resolved   

Priority: High   

Assignee: Chris Roberts   

Category: Compute resources - VMware   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged: Yes Found in Releases: 1.15.6

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

With or without options:

# hammer host update --name vmware-host.local --comment test 

Could not update the host:

  Failed to update a compute CHX-VC-CIS (VMware) instance vmware-host.local: undefined method `[]'

 for nil:NilClass

# hammer host update --name vmware-host.local

Could not update the host:

  Failed to update a compute CHX-VC-CIS (VMware) instance vmware-host.local: undefined method `[]'

 for nil:NilClass

 Logs:

2017-08-23 21:09:33 8842e4cd [app] [W] Failed to update a compute CHX-VC-CIS (VMware) instance vmw

are-host.local: undefined method `[]' for nil:NilClass

 | NoMethodError: undefined method `[]' for nil:NilClass

 | /usr/share/foreman/app/models/compute_resources/foreman/model/vmware.rb:435:in `block in save_v

m'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/fog-core-1.42.0/lib/fog/core/collection.rb:19:in `

each'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/fog-core-1.42.0/lib/fog/core/collection.rb:19:in `

each'

 | /usr/share/foreman/app/models/compute_resources/foreman/model/vmware.rb:433:in `save_vm'

 | /usr/share/foreman/app/models/concerns/orchestration/compute.rb:203:in `setComputeUpdate'

 | /usr/share/foreman/app/models/concerns/orchestration.rb:216:in `execute'

 | /usr/share/foreman/app/models/concerns/orchestration.rb:144:in `block in process'

 | /usr/share/foreman/app/models/concerns/orchestration.rb:136:in `each'

 | /usr/share/foreman/app/models/concerns/orchestration.rb:136:in `process'

 | /usr/share/foreman/app/models/concerns/orchestration.rb:44:in `around_save_orchestration'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:432:in `block in make_lambda'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `block in halting'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `block in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.
rb:92:in `__run_callbacks__'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:778:in `_run_save_callbacks'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/callbacks.rb

:302:in `create_or_update'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/persistence.

rb:120:in `save'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/validations.

rb:37:in `save'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/attribute_me

thods/dirty.rb:21:in `save'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/transactions

.rb:286:in `block (2 levels) in save'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/transactions

.rb:351:in `block in with_transaction_returning_status'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/connection_a

dapters/abstract/database_statements.rb:213:in `block in transaction'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/connection_a

dapters/abstract/transaction.rb:184:in `within_new_transaction'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/connection_a

dapters/abstract/database_statements.rb:213:in `transaction'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/transactions

.rb:220:in `transaction'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/transactions

.rb:348:in `with_transaction_returning_status'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/transactions

.rb:286:in `block in save'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/transactions

.rb:301:in `rollback_active_record_state!'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/transactions

.rb:285:in `save'

 | /usr/share/foreman/app/models/concerns/foreman/sti.rb:29:in `save_with_type'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/foreman-tasks-0.9.4/app/models/foreman_tasks/conce

rns/action_triggering.rb:25:in `block in save_with_dynflow_task_wrap'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/foreman-tasks-0.9.4/app/models/foreman_tasks/conce

rns/action_triggering.rb:119:in `dynflow_task_wrap'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/foreman-tasks-0.9.4/app/models/foreman_tasks/conce

rns/action_triggering.rb:25:in `save_with_dynflow_task_wrap'

 | /usr/share/foreman/app/controllers/api/v2/hosts_controller.rb:147:in `update'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal/impl

icit_render.rb:4:in `send_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/abstract_controller/base.rb:

198:in `process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal/rend

ering.rb:10:in `process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/abstract_controller/callback

s.rb:20:in `block in process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:117:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:117:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:555:in `block (2 levels) in compile'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:498:in `block (2 levels) in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `block (2 levels) in halting'

 | /usr/share/foreman/app/controllers/api/v2/base_controller.rb:152:in `disable_json_root'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:432:in `block in make_lambda'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.
rb:312:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `block in halting'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `block in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:498:in `block (2 levels) in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `block (2 levels) in halting'

 | /usr/share/foreman/app/controllers/concerns/application_shared.rb:15:in `set_timezone'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:432:in `block in make_lambda'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `block in halting'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `block in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:498:in `block (2 levels) in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `block (2 levels) in halting'

 | /usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in `clear_thread'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:432:in `block in make_lambda'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `block in halting'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `block in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:498:in `block (2 levels) in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `block (2 levels) in halting'

 | /usr/share/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12:in `set_top

bar_sweeper_controller'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:432:in `block in make_lambda'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `block in halting'
 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `block in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:498:in `block (2 levels) in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:313:in `block (2 levels) in halting'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.4.1/lib/audited/sweeper.rb:14:in `around

'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:455:in `public_send'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:455:in `block in make_lambda'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:312:in `block in halting'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:497:in `block in around'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:505:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:92:in `__run_callbacks__'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:778:in `_run_process_action_callbacks'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:81:in `run_callbacks'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/abstract_controller/callback

s.rb:19:in `process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal/resc

ue.rb:29:in `process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal/inst

rumentation.rb:32:in `block in process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/notificati

ons.rb:164:in `block in instrument'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/notificati

ons/instrumenter.rb:20:in `instrument'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/notificati

ons.rb:164:in `instrument'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal/inst

rumentation.rb:30:in `process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal/para

ms_wrapper.rb:250:in `process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/railties/con

troller_runtime.rb:18:in `process_action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/abstract_controller/base.rb:

137:in `process'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionview-4.2.5.1/lib/action_view/rendering.rb:30:

in `process'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal.rb:1

96:in `dispatch'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal/rack

_delegation.rb:13:in `dispatch'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_controller/metal.rb:2

37:in `block in action'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/routing/rout
e_set.rb:74:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/routing/rout

e_set.rb:74:in `dispatch'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/routing/rout

e_set.rb:43:in `serve'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/routing/mapp

er.rb:49:in `serve'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/journey/rout

er.rb:43:in `block in serve'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/journey/rout

er.rb:30:in `each'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/journey/rout

er.rb:30:in `serve'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/routing/rout

e_set.rb:815:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.4.0/lib/apipie/static_dispatcher.rb

:65:in `call'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.4.0/lib/apipie/extractor/recorder.r

b:132:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.4.0/lib/apipie/middleware/checksum_

in_headers.rb:27:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/etag.rb:24:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/conditionalget.rb:38:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/head.rb:13:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/p

arams_parser.rb:27:in `call'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.4.4/lib/katello/params_parser_wrapper.rb

:12:in `call'

 | /usr/share/foreman/lib/middleware/catch_json_parse_errors.rb:8:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/f

lash.rb:260:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/session/abstract/id.rb:225:in `

context'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/session/abstract/id.rb:220:in `

call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/c

ookies.rb:560:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/query_cache.

rb:36:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activerecord-4.2.5.1/lib/active_record/connection_a

dapters/abstract/connection_pool.rb:653:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/c

allbacks.rb:29:in `block in call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:88:in `__run_callbacks__'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:778:in `_run_call_callbacks'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/callbacks.

rb:81:in `run_callbacks'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/c

allbacks.rb:27:in `call'
 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/r

emote_ip.rb:78:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/d

ebug_exceptions.rb:17:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

how_exceptions.rb:30:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/railties-4.2.5.1/lib/rails/rack/logger.rb:38:in `ca

ll_app'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/railties-4.2.5.1/lib/rails/rack/logger.rb:22:in `ca

ll'

 | /usr/share/foreman/lib/middleware/tagged_logging.rb:18:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/r

equest_id.rb:21:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/methodoverride.rb:22:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/runtime.rb:18:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/activesupport-4.2.5.1/lib/active_support/cache/stra

tegy/local_cache_middleware.rb:28:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/actionpack-4.2.5.1/lib/action_dispatch/middleware/s

tatic.rb:116:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/sendfile.rb:113:in `call'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/secure_headers-3.4.1/lib/secure_headers/middleware

.rb:12:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/railties-4.2.5.1/lib/rails/engine.rb:518:in `call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/railties-4.2.5.1/lib/rails/application.rb:165:in `c

all'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/railties-4.2.5.1/lib/rails/railtie.rb:194:in `publi

c_send'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/railties-4.2.5.1/lib/rails/railtie.rb:194:in `metho

d_missing'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/urlmap.rb:66:in `block in call'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/urlmap.rb:50:in `each'

 | /opt/rh/sclo-ror42/root/usr/share/gems/gems/rack-1.6.2/lib/rack/urlmap.rb:50:in `call'

 | /usr/share/passenger/phusion_passenger/rack/thread_handler_extension.rb:74:in `process_request'

 | /usr/share/passenger/phusion_passenger/request_handler/thread_handler.rb:141:in `accept_and_pro

cess_next_request'

 | /usr/share/passenger/phusion_passenger/request_handler/thread_handler.rb:109:in `main_loop'

 | /usr/share/passenger/phusion_passenger/request_handler.rb:455:in `block (3 levels) in start_thr

eads'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/logging-1.8.2/lib/logging/diagnostic_context.rb:32

3:in `call'

 | /opt/theforeman/tfm/root/usr/share/gems/gems/logging-1.8.2/lib/logging/diagnostic_context.rb:32

3:in `block in create_with_logging_context'

2017-08-23 21:09:33 8842e4cd [app] [E] Unprocessable entity Host::Managed (id: 112):

 |   Failed to update a compute CHX-VC-CIS (VMware) instance vmware-host.local: undefined method `

[]' for nil:NilClass

History

#1 - 08/30/2017 02:45 PM - John Mitsch

- Project changed from Katello to Foreman

This looks like a foreman bug, I am switching it to the foreman project. If its katello-related please comment with some more details.

#2 - 08/31/2017 02:01 AM - Ivan Necas

- Category set to Compute resources - VMware

#3 - 10/06/2017 04:09 AM - Ronan Lanore

- Priority changed from Normal to High

Hi, We have the same problem after upgrade from 1.12 to 1.15.4.

We are unable to spawn new vm or update en existant vm with foreman now !

After little read of code i think it's comming from this commit:

https://github.com/theforeman/foreman/commit/2309e9e1487c19fdecc93c771687d6f25eb1654d#diff-4443c0de1e4e867a30d3c878b9cb64e9
Into /usr/share/foreman/app/models/compute_resources/foremodel/vmware.rb at line 434

def save_vm(uuid, attr)

      vm = find_vm_by_uuid(uuid)

      vm.attributes.merge!(attr.deep_symbolize_keys)

      #volumes are not part of vm.attributes so we have to set them seperately if needed

      if attr.has_key?(:volumes_attributes)

        vm.volumes.each do |vm_volume|

          volume_attrs = attr[:volumes_attributes].values.detect {|vol| vol[:id] == vm_volume.id} 

# This line return 'nil'

          Rails.logger.info("RLA RLA: volumes class #{volume_attrs.class}")

          Rails.logger.info("RLA RLA: volumes attr #{volume_attrs}")

          vm_volume.size_gb = volume_attrs[:size_gb] # This line do the undefined method `[]' for nil:NilClass

        end

      end

      vm.save

    end

 And an example attr properties is

attr: {"cpus"=>"1", 

  "corespersocket"=>"2",

  "memory_mb"=>"4096",

  "cluster"=>"", 

  "path"=>"/Datacenters/CLS-DEV/vm", 

  "guest_id"=>"otherGuest", 

  "scsi_controller_type"=>"ParaVirtualSCSIController", 

  "hardware_version"=>"Default", 

  "memoryHotAddEnabled"=>"1", 

  "cpuHotAddEnabled"=>"1", 

  "add_cdrom"=>"0", 

  "annotation"=>"", 

  "volumes_attributes"=>{

    "0"=>{

      "datastore"=>"EVA5_dev1_crm_vm5",

      "name"=>"Hard disk", 

      "size_gb"=>"16", 

      "thin"=>"true",

      "eager_zero"=>"false" 

    }

  }

}

 This return nil for us.

The volumes_attributes is completely wrong for our VM

It's seem related to :

http://projects.theforeman.org/issues/19990

http://projects.theforeman.org/issues/19660

http://projects.theforeman.org/issues/19978

#4 - 01/09/2018 03:16 PM - Anthony Chevalet

Using the API, the workaround is to pass compute_attributes (GET hosts/:id/vm_compute_attributes) in the post request.

#5 - 01/09/2018 04:18 PM - Anthony Chevalet

$ curl -ksin -H Content-type:application/json -X PUT https://foreman/api/hosts/539 -d '{"host": {"comment": "t

est1"}}'

HTTP/1.1 422 Unprocessable Entity 

...

$ ca=$(curl -ksn -H Content-type:application/json -X GET https://foreman/api/hosts/539/vm_compute_attributes)

$

$ curl -ksin -H Content-type:application/json -X PUT https://foreman/api/hosts/539 -d '{"host": {"comment": "t

est1", "compute_attributes": '"$ca"'}}'

HTTP/1.1 200 OK

...

 Unfortunately this workaround does not work for hammer with options --compute-attributes, --volume or --interface.

#7 - 06/13/2018 10:41 PM - Andrew Cooper

Is there any update on this? We are seeing the same thing with our integrations to the API (we do not use hammer).   We will try the workaround of
requesting and passing the compute_arguments, but it would be nice to see a long term solution.

#8 - 06/26/2018 09:48 AM - Tomer Brisker

- translation missing: en.field_release set to 353

- Triaged set to No

#9 - 06/26/2018 09:48 AM - Tomer Brisker

- Triaged changed from No to Yes

#10 - 07/19/2018 01:19 PM - Chris Roberts

- Assignee set to Chris Roberts

#11 - 08/29/2018 12:45 PM - Tomer Brisker

- Target version changed from 1.19.0 to 1.19.1

Pushing out to 1.19.1 as 1.19.0 release is imminent and this has not been resolved yet.

#12 - 11/06/2018 03:06 PM - Tomer Brisker

- Target version changed from 1.19.1 to 961

1.19.1 release is in progress and this was not fixed in time, pushing out to 1.19.2.

#13 - 11/06/2018 04:04 PM - Anthony Chevalet

It works for me on 1.18.1. (still impacted by #20725 though)

#14 - 12/04/2018 01:26 PM - Tomer Brisker

- Status changed from New to Resolved

- Target version deleted (961)

comment #13 seems to indicate this has been resolved in 1.18.1. Please reopen if issue persists.
